unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  jpeg, Layers, ExtCtrls;

type
  TForm1 = class(TForm)
    ImageLayer1: TImageLayer;
    ButtonLayer1: TButtonLayer;
    ButtonLayer2: TButtonLayer;
    ButtonLayer3: TButtonLayer;
    ButtonLayer4: TButtonLayer;
    ButtonLayer5: TButtonLayer;
    ButtonLayer6: TButtonLayer;
    ButtonLayer7: TButtonLayer;
    ButtonLayer8: TButtonLayer;
    ButtonLayer9: TButtonLayer;
    ButtonLayer10: TButtonLayer;
    ImageLibrary1: TImageLibrary;
    ButtonLayer11: TButtonLayer;
    ButtonLayer12: TButtonLayer;
    procedure DragBegin(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DragMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImageLayer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    FStart: TPoint;
    FPrev: TButtonLayer;
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.DragBegin(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then begin
    if (FPrev <> Sender) and (FPrev <> Nil) then FPrev.MaskIndex := 2;
    FStart := Point(X,Y);
    FPrev := TButtonLayer(Sender);
    FPrev.BringToFront;
    FPrev.MaskIndex := 1;
    ImageLayer1.Update;
  end;
end;

procedure TForm1.DragMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  with TButtonLayer(Sender) do
    if csLButtonDown in ControlState then
      SetBounds(((Left + (X - FStart.X)) div 2) * 2, ((Top + (Y - FStart.Y)) div 2) * 2, Width, Height);
  ImageLayer1.Update;
end;

procedure TForm1.ImageLayer1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) and (FPrev <> Nil) then FPrev.MaskIndex := 2;
end;

end.
