unit UMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  jpeg, Channels, Layers, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    ImageLayer1: TImageLayer;
    Layer1: TLayer;
    Image2: TImageLayer;
    ButtonLayer1: TButtonLayer;
    PopupMenu1: TPopupMenu;
    Zoom1: TMenuItem;
    AutoScroll1: TMenuItem;
    Scale1: TMenuItem;
    Auto1: TMenuItem;
    Stretch1: TMenuItem;
    N1001: TMenuItem;
    N501: TMenuItem;
    N251: TMenuItem;
    N1251: TMenuItem;
    ButtonLayer2: TButtonLayer;
    ButtonLayer3: TButtonLayer;
    procedure ButtonLayer1Click(Sender: TObject);
    procedure N1251Click(Sender: TObject);
    procedure AutoScroll1Click(Sender: TObject);
    procedure Auto1Click(Sender: TObject);
    procedure Stretch1Click(Sender: TObject);
    procedure ImageLayer1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ButtonLayer1Click(Sender: TObject);
begin
  Application.MessageBox('Copyright (c) 1998 by Alexey Lavnikov'^M'Gavinna International',
                         'Layers Demo',
                         MB_OK or MB_IconInformation);
end;

procedure Check(Sender: TObject);
begin
  TMenuItem(Sender).Checked := True;
end;

procedure TForm1.N1251Click(Sender: TObject);
begin
  Image2.Scale := TJpegScale(TComponent(Sender).Tag);
  Check(Sender);
end;

procedure TForm1.AutoScroll1Click(Sender: TObject);
begin
  Image2.ImageAlign := aLeftUp;
  Image2.AutoScroll := True;
  Check(Sender);
end;

procedure TForm1.Auto1Click(Sender: TObject);
begin
  Image2.ImageAlign := aScale;
  Check(Sender);
end;

procedure TForm1.Stretch1Click(Sender: TObject);
begin
  Image2.ImageAlign := aStretch;
  Check(Sender);
end;

procedure TForm1.ImageLayer1Click(Sender: TObject);
begin
  Application.MessageBox('Transparency by Alexey Lavnikov'^M'Gavinna International',
                         'Layers Demo',
                         MB_OK or MB_IconInformation);
end;

end.
